<template>
  <q-modal
    v-model="isSignInModalActive"
    minimized
    ref="modalRef"
    @close="reset"
    @show="focus"
  >
    <div style="padding: 30px">
      <div class="q-headline">{{$t('signIn.title')}}</div>
        <q-field
          :error="errors.hasOwnProperty('login')"
          :error-label="errors.login"
        >
          <q-input
            @keydown.enter="submit"
            :disabled="isProcessing"
            v-model="model.login"
            :float-label="$t('signIn.field.login')"
            ref="loginInput"
          />
        </q-field>
        <q-field
          :error="errors.hasOwnProperty('password')"
          :error-label="errors.password"
        >
          <q-input
            @keydown.enter="submit"
            :disabled="isProcessing"
            v-model="model.password"
            :float-label="$t('signIn.field.password')"
            type="password"
          />
        </q-field>
        <div class="q-mt-lg">
          <q-btn
            @click="submit"
            color="primary"
            class="full-width"
            :loading="isProcessing"
            :disabled="isProcessing"
          >
            {{$t('signIn.submit')}}
          </q-btn>
        </div>
    </div>
  </q-modal>
</template>

<script>
import apiMixin from '../../utilities/apiMixin'

export default {
  name: 'SignInModal',
  computed: {
    isSignInModalActive: {
      get() { return this.$store.state.user.isSignInModalActive },
      set(val) { this.$store.commit('user/isSignInModalActive', val) },
    },
  },
  mixins: [apiMixin],
  methods: {
    reset() {
      this.model.login = null
      this.model.password = null
      this.isProcessing = false
      this.errors = {}
    },
    focus() {
      this.$refs.loginInput.focus()
    },
    submit(e) {
      e.preventDefault()

      this.isProcessing = true
      this.errors = {}

      const payload = {
        user_name: this.model.login,
        user_password: this.model.password,
      }

      this.$axios.post(this.getApiUrl('auth'), payload, {
        validateStatus: false,
      }).then(({ data: { error, message, token } }) => {
        this.isProcessing = false
        if (error) {
          this.errors.password = message
        } else if (token) {
          this.$store.commit('user/isAuthorized', {
            token,
            login: this.model.login,
          })
          this.$store.commit('user/isSignInModalActive', false)
        }
      })
    },
  },
  data() {
    return {
      isProcessing: false,
      errors: {},
      model: {
        login: null,
        password: null,
      },
    }
  },
}
</script>

<style scoped>

</style>
